#! /usr/local/bin/ruby -Ke

module Constant

  MAXLEVEL  = 11 # /* max # levels in the dungeon */
  MAXVLEVEL =  3 # /* max # of levels in the temple of the luran	*/
  MINLEVEL  =  1
  
  MAXX = 67 # 󥸥
  MAXY = 17 # Կ

  SCORESIZE = 10 # /* this is the number of people on a scoreboard max */
  MAXPLEVEL = 100 # /* maximum player level allowed */

  MAXMONST = 56 # /* maximum # monsters in the dungeon	*/
  ALL_MONSTERS = 64

  SPNUM = 38 # /* maximum number of spells in existance	*/
  # MAXSCROLL = 28 # /* maximum number of scrolls that are possible */
  # MAXPOTION = 35 # /* maximum number of potions that are possible */
  MAXSCROLL = 24 # /* maximum number of scrolls that are possible */
  MAXPOTION = 24 # /* maximum number of potions that are possible */


  TIMELIMIT = 30000 # /*the maximum number of moves before the game is called */
  TAXRATE = 1/20 # /*	the tax rate for the LRS */
  MAXOBJ  =   93 # /* the maximum number of objects   n < MAXOBJ */

  module Gameserver
    MAXLEVEL  = 11 # /* max # levels in the dungeon */
    MAXVLEVEL =  3 # /* max # of levels in the temple of the luran	*/
    MINLEVEL  =  1
  end

  
  module Cavelevel
    MAXLEVEL  = 11 # /* max # levels in the dungeon */
    MAXVLEVEL =  3 # /* max # of levels in the temple of the luran	*/

    MAXX = 67 # 󥸥
    MAXY = 17 # Կ

  end

  module Client

    DROWS   = 24
    DCOLS   = 80
    DSTATUS =  2

    ESC = 27
    
    MAXX = 67
    MAXY = 17

    MROWS = DROWS - ( MAXY + DSTATUS )
    MCOLS = DCOLS
        
    OBJCHAR = " ATOP%^F&^+M=%^$$f*OD#~][[)))(((||||||||{?!BC}o:@.<<<<EVV))([[]]](^ [H*** ^^ S tsTLc......... .................................."
    MONCHAR = " BGHJKOScjtAELNQRZabhiCTYdegmvzFWflorXVIpqsyUkMwDDPxnDDuD        ..............................................................."

    DIRS = "hjklyubn"
    
  end
    
  
  module Monster
    
    BAT              =  1
    GNOME            =  2
    HOBGOBLIN        =  3
    JACKAL           =  4
    KOBOLD           =  5
    ORC              =  6
    SNAKE            =  7
    CENTIPEDE        =  8
    JACULI           =  9
    TROGLODYTE       = 10
    ANT              = 11
    EYE              = 12
    LEPRECHAUN       = 13
    NYMPH            = 14
    QUASIT           = 15
    RUSTMONSTER      = 16
    ZOMBIE           = 17
    ASSASSINBUG      = 18
    BUGBEAR          = 19
    HELLHOUND        = 20
    ICELIZARD        = 21
    CENTAUR          = 22
    TROLL            = 23
    YETI             = 24
    WHITEDRAGON      = 25
    ELF              = 26
    CUBE             = 27
    METAMORPH        = 28
    VORTEX           = 29
    ZILLER           = 30
    VIOLETFUNGI      = 31
    WRAITH           = 32
    FORVALAKA        = 33
    LAMANOBE         = 34
    OSEQUIP          = 35
    ROTHE            = 36
    XORN             = 37
    VAMPIRE          = 38
    INVISIBLESTALKER = 39
    POLTERGEIST      = 40
    DISENCHANTRESS   = 41
    SHAMBLINGMOUND   = 42
    YELLOWMOLD       = 43
    UMBERHULK        = 44
    GNOMEKING        = 45
    MIMIC            = 46
    WATERLORD        = 47
    BRONZEDRAGON     = 48
    GREENDRAGON      = 49
    PURPLEWORM       = 50
    XVART            = 51
    SPIRITNAGA       = 52
    SILVERDRAGON     = 53
    PLATINUMDRAGON   = 54
    GREENURCHIN      = 55
    REDDRAGON        = 56
    DEMONLORD_1      = 57
    DEMONLORD_2      = 58
    DEMONLORD_3      = 59
    DEMONLORD_4      = 60
    DEMONLORD_5      = 61
    DEMONLORD_6      = 62
    DEMONLORD_7      = 63
    DEMONPRINCE      = 64

  end

  module Spell

    PROTECTION           =  0
    MAGICMISSILE         =  1
    DEXTERITY            =  2
    SLEEP                =  3
    CHARMMONSTER         =  4
    SONICSPEAR           =  5
    WEB                  =  6
    STRENGTH             =  7
    ENLIGHTENMENT        =  8
    HEALING              =  9
    CUREBLINDNESS        = 10
    CREATEMONSTER        = 11 
    PHANTASMALFORCES     = 12
    INVISIBILITY         = 13
    FIREBALL             = 14
    COLD                 = 15
    POLYMORPH            = 16
    CANCELLATION         = 17
    HASTESELF            = 18
    CLOUDKILL            = 19
    VAPORIZEROCK         = 20
    DEHYDRATION          = 21
    LIGHTNING            = 22
    DRAINLIFE            = 23
    INVULNERABILITY      = 24
    FLOOD                = 25
    FINGEROFDEATH        = 26
    SCAREMONSTER         = 27
    HOLDMONSTER          = 28
    TIMESTOP             = 29
    TELEPORTAWAY         = 30
    MAGICFIRE            = 31
    SPHEREOFANNIHILATION = 32
    GENOCIDE             = 33
    SUMMONDAEMON         = 34
    WALKTHROUGHWALLS     = 35
    ALTERREALITY         = 36
    PERMANENCE           = 37

  end

  module Object
    # /* defines for the objects in the game */

    ONOTHING         =  0
    OALTAR           =  1
    OTHRONE          =  2
    OORB             =  3
    OPIT             =  4
    OSTAIRSUP        =  5
    OELEVATORUP      =  6
    OFOUNTAIN        =  7
    OSTATUE          =  8
    OTELEPORTER      =  9
    OSCHOOL          = 10
    OMIRROR          = 11
    ODNDSTORE        = 12
    OSTAIRSDOWN      = 13
    OELEVATORDOWN    = 14
    OBANK2           = 15
    OBANK            = 16
    ODEADFOUNTAIN    = 17
    OMAXGOLD         = 70
    OGOLDPILE        = 18
    OOPENDOOR        = 19
    OCLOSEDDOOR      = 20
    OWALL            = 21
    OTRAPARROW       = 66
    OTRAPARROWIV     = 67 # ʤ

    OLARNEYE         = 22

    OPLATE           = 23
    OCHAIN           = 24
    OLEATHER         = 25
    ORING            = 60
    OSTUDLEATHER     = 61
    OSPLINT          = 62
    OPLATEARMOR      = 63
    OSSPLATE         = 64
    OSHIELD          = 68
    OELVENCHAIN      = 92

    OSWORDofSLASHING = 26
    OHAMMER          = 27
    OSWORD           = 28
    O2SWORD          = 29
    OSPEAR           = 30
    ODAGGER          = 31
    OBATTLEAXE       = 57
    OLONGSWORD       = 58
    OFLAIL           = 59
    OLANCE           = 65
    OVORPAL          = 90
    OSLAYER          = 91

    ORINGOFEXTRA     = 32
    OREGENRING       = 33
    OPROTRING        = 34
    OENERGYRING      = 35
    ODEXRING         = 36
    OSTRRING         = 37
    OCLEVERRING      = 38
    ODAMRING         = 39

    OBELT            = 40

    OSCROLL          = 41
    OPOTION          = 42
    OBOOK            = 43
    OCHEST           = 44
    OAMULET          = 45

    OORBOFDRAGON     = 46
    OSPIRITSCARAB    = 47
    OCUBEofUNDEAD    = 48
    ONOTHEFT         = 49

    ODIAMOND         = 50
    ORUBY            = 51
    OEMERALD         = 52
    OSAPPHIRE        = 53

    OENTRANCE        = 54
    OVOLDOWN         = 55
    OVOLUP           = 56
    OHOME            = 69

    OKGOLD           = 71
    ODGOLD           = 72
    OIVDARTRAP       = 73 # ʤ
    ODARTRAP         = 74
    OTRAPDOOR        = 75
    OIVTRAPDOOR      = 76 # ʤ
    OTRADEPOST       = 77
    OIVTELETRAP      = 78 # ʤ
    ODEADTHRONE      = 79
    OANNIHILATION    = 80 # /* sphere of annihilation */
    OTHRONE2         = 81 #
    OLRS             = 82 # /* Larn Revenue Service */
    OCOOKIE          = 83
    OURN             = 84
    OBRASSLAMP       = 85
    OHANDofFEAR      = 86 # /* hand of fear */
    OSPHTAILSMAN     = 87 # /* tailsman of the sphere */
    OWWAND           = 88 # /* wand of wonder */
    OPSTAFF          = 89 # /* staff of power */
    # /* used up to 92 */
    OEXIT            = 93 # RubyLarnꥸʥ롣

     MAXSCROLL = 24 # /* maximum number of scrolls that are possible */
  MAXPOTION = 24 # /* maximum number of potions that are possible */
    
    
  end

  module Player

    STRENGTH = 0 # /* characters physical strength not due to objects */
    INTELLIGENCE = 1
    WISDOM = 2
    CONSTITUTION = 3
    DEXTERITY = 4
    CHARISMA = 5
    HPMAX = 6
    HP = 7
    GOLD = 8
    EXPERIENCE = 9
    LEVEL = 10
    REGEN = 11
    WCLASS = 12
    AC = 13
    BANKACCOUNT = 14
    SPELLMAX = 15
    SPELLS = 16
    ENERGY = 17
    ECOUNTER = 18
    MOREDEFENSES = 19
    WEAR = 20
    PROTECTIONTIME = 21
    WIELD = 22
    AMULET = 23
    REGENCOUNTER = 24
    MOREDAM = 25
    DEXCOUNT = 26
    STRCOUNT = 27
    BLINDCOUNT = 28
    CAVELEVEL = 29
    CONFUSE = 30
    ALTPRO = 31
    HERO = 32
    CHARMCOUNT = 33
    INVISIBILITY = 34
    CANCELLATION = 35
    HASTESELF = 36
    EYEOFLARN = 37
    AGGRAVATE = 38
    GLOBE = 39
    TELEFLAG = 40
    SLAYING = 41
    NEGATESPIRIT = 42
    SCAREMONST = 43
    AWARENESS = 44
    HOLDMONST = 45
    TIMESTOP = 46
    HASTEMONST = 47
    CUBEofUNDEAD = 48
    GIANTSTR = 49
    FIRERESISTANCE = 50
    BESSMANN = 51
    NOTHEFT = 52
    HARDGAME = 53
    CPUTIME = 54
    BYTESIN = 55
    BYTESOUT = 56
    MOVESMADE = 57
    MONSTKILLED = 58
    SPELLSCAST = 59
    LANCEDEATH = 60
    SPIRITPRO = 61
    UNDEADPRO = 62
    SHIELD = 63
    STEALTH = 64
    ITCHING = 65
    LAUGHING = 66
    DRAINSTRENGTH = 67
    CLUMSINESS = 68
    INFEEBLEMENT = 69
    HALFDAM = 70
    SEEINVISIBLE = 71
    FILLROOM = 72
    RANDOMWALK = 73
    SPHCAST = 74 #      /* nz if an active sphere of annihilation */
    WTW = 75 #          /* walk through walls */
    STREXTRA = 76 #     /* character strength due to objects or enchantments */
    TMP = 77 #  /* misc scratch space */
    LIFEPROT = 78 # /* life protection counter */

    SLEEP   = 79  # RubyLarn
    
    TIMELIMIT = 30000
    SPNUM = 38

    
  end

  
  
end
