#! /usr/local/bin/ruby -Ke

=begin

Larnobject:
ɶȤäƥ䡢櫤䳬ʤʤɤϷޤȤ᤿饹
RubyRogueǤ̡äΤ礷ưƤޤ

=end

require "constant"

class Larnobject

  include Constant::Object

  # id:  ƥμࡣ
  # arg: ƥղ°
  #      ΰϥåפ䡢ʪμʤɤǤ

  attr_reader :id, :arg
  
  def initialize( id, arg = 0 )

    raise unless ( @id = id )
    @arg = arg
    
  end

  def method_missing( m, *par )
    false
  end

  def Larnobject.mirror
    self.new( OMIRROR )
  end

  
  # ˡ38ࡣ
  
  SPLEV = [ 1, 4, 9, 14, 18, 22, 26, 29, 32, 35, 37, 37, 37, 37, 37 ]

  def Larnobject.newbook( level )
  
    if ( level <= 3 )
      id = rand( SPLEV[ level ] )
    else
      id  = rand( SPLEV[ level ] ) + 1
      id += 9 if ( id < 10 )
    end

    self.new( OBOOK, id )

  end

  # ʪ24ࡣ
  # 24νиɽ

  SCPROB = [ 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8,
    9, 9, 9, 9, 10, 10, 10, 10, 11, 11, 11, 12, 12, 12, 13, 13, 13, 13, 14, 14,
        15, 15, 16, 16, 16, 17, 17, 18, 18, 19, 19, 19, 20, 20, 20, 20, 21, 22,
        22, 22, 23 ]
  
  def Larnobject.newscroll( arg = nil )
    arg = SCPROB[ rand( 81 ) ] unless arg
    self.new( OSCROLL,  arg )
  end

  # 24ࡣνиɽ

  POTPROB = [ 0, 0, 1, 1, 1, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 9, 9, 9,
    10, 10, 10, 11, 11, 12, 12, 13, 14, 15, 16, 17, 18, 19, 19,
    20, 20, 22, 22, 23, 23 ]
  
  def Larnobject.newpotion( arg = nil )
    arg = POTPROB[ rand( 41 ) ] unless arg
    self.new( OPOTION, arg )
  end
  
  def Larnobject.newgold( level )
    self.new( OGOLDPILE, rnd( ( level + 1 ) * 10 ) + level * 10 + 10 )
  end

  def Larnobject.newdiamond( level )
    self.new( ODIAMOND, rnd( 10 * level + 1 ) + 10 )
  end

  def Larnobject.newruby( level )
    self.new( ORUBY, rnd( 6 * level + 1 ) +  6 )
  end

  def Larnobject.newemerald( level )
    self.new( OEMERALD, rnd( 4 * level + 1 ) +  4 )
  end

  def Larnobject.newsapphire( level )
    self.new( OSAPPHIRE, rnd( 3 * level + 1 ) +  2 )
  end

  NPLT = [ 0, 0, 0, 0, 1, 1, 2, 2, 3, 4 ]

  def Larnobject.newplate
    self.new( OPLATE, NPLT[ ( ( $HARDGAME > 0 ) ? rund( 4 ) : rund( 10 ) ) ] ) 
  end

  NDGG  = [ 0, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 4, 5 ]       # ûΰɽ

  def Larnobject.newdagger
    self.new( ODAGGER, NDGG[ rand( 13 ) ] )
  end
  
  NLPTS = [ 0, 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 5, 6, 7 ] # 鳻ΰɽ

  def Larnobject.newleather
    self.new( OLEATHER, NLPTS[ rand( ( $HARDGAME > 0 ) ? 13 : 15 ) ] )
  end

  NCH = [ 0, 0, 0, 1, 1, 1, 2, 2, 3, 4 ]
  
  def Larnobject.newchain
    self.new( OCHAIN, NCH[ rand( 10 ) ] )
  end

  NSW = [ 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 3 ]

  def Larnobject.newsword
    self.new( OLONGSWORD , NSW[ rand( ( $HARDGAME > 0 ) ? 6 : 13 ) ] )
  end

  COURSE = {
    ?a => 10,
    ?b => 15,
    ?c => 10,
    ?d => 20,
    ?e => 10,
    ?f => 10,
    ?g => 10,
    ?h =>  5,
  }
  
  def Larnobject.school
    self.new( OSCHOOL, COURSE.dup )
  end

  def finished?( course )
    !( @arg.include?( course ) )
  end

  def coursetime( course )
    @arg[ course ]
  end
  
  def finished( course )
    @arg.delete( course )
  end
  

  def Larnobject.something( level )

    tmp = 32
    tmp = 35 if ( level > 4 )
    tmp = 37 if ( level > 6 )

    case ( rnd( tmp ) )
    when ( 1 .. 4 )
      Larnobject.newscroll
    when ( 5 .. 8 )
      Larnobject.newpotion
    when ( 9 .. 12 ) # ⡣
      Larnobject.newgold( level )
    when ( 13 .. 16 )
      Larnobject.newbook( level )
    when ( 17 .. 19 )
      Larnobject.newdagger
    when ( 20 .. 22 )
      Larnobject.newleather
    when 23 
      self.new( OREGENRING, rand( level / 3 + 1 ) )
    when 24
      self.new( OPROTRING, rnd( level / 4 + 1 ) )
    when 25
      self.new( OENERGYRING, rand( level / 4 + 1 ) )
    when 26
      self.new( ODEXRING, rnd( level / 4 + 1 ) )
    when 27
      self.new( OSTRRING, rnd( level / 2 + 1 ) )
    when 28
      self.new( OSPEAR, rand( level / 3 + 1 ) )
    when 29
      self.new( OBELT, rand( level / 2 + 1 ) )
    when 30
      self.new( ORING, rand( level / 2 + 1 ) )
    when 31
      self.new( OSTUDLEATHER, rand( level / 2 + 1 ) )
    when 32 
      self.new( OSHIELD, rand( level / 3 + 1 ) )
    when 33
      self.new( OFLAIL, rand( level / 2 + 1 ) )
    when 34
      Larnobject.newchain
    when 35
      self.new( O2SWORD,  rand( level / 3 + 1 ) )
    when 36
      Larnobject.newplate
    when 37
      Larnobject.newsword
    end

  end

  def home?       ; @id == OHOME     ; end
  def entrance?   ; @id == OENTRANCE ; end
  def stairsup?   ; @id == OSTAIRSUP ; end
  def stairsdown? ; @id == OSTAIRSDOWN ; end
  def cookie?     ; @id == OCOOKIE ; end

  def statue?     ; @id == OSTATUE ; end
  def mirror?     ; @id == OMIRROR ; end
  
  def gold?
    @id == OGOLDPILE ||  @id == OMAXGOLD || @id == OKGOLD ||
      @id == ODGOLD 
  end

  def for_gold_detection?
    @id == OGOLDPILE || @id == OMAXGOLD
  end

  def for_treasure_finding?
    for_gold_detection? || gem? || larneye?
  end

  

  def larneye? ; @id == OLARNEYE ; end
  def dexring? ; @id == ODEXRING ; end
  def strring? ; @id == OSTRRING ; end
  def cleverring? ; @id == OCLEVERRING ; end
  def protring? ; @id == OPROTRING ; end
  def damring?  ; @id == ODAMRING? ; end

  def belt? ; @id == OBELT ; end

  def book? ; @id == OBOOK ; end

  def hammer? ; @id == OHAMMER ; end
  
  def sword_of_slashing? ; @id == OSWORDofSLASHING ; end

  SPELCODE = [
    "pro",  "mle",  "dex",  "sle",  "chm",  "ssp",
    "web",  "str",  "enl",  "hel",  "cbl",  "cre",  "pha",  "inv",
    "bal",  "cld",  "ply",  "can",  "has",  "ckl",  "vpr",
    "dry",  "lit",  "drl",  "glo",  "flo",  "fgr",
    "sca",  "hld",  "stp",  "tel",  "mfi", # /* 31 */
    "sph",  "gen",  "sum",  "wtw",  "alt",  "per"
  ]
  
  def spelcode
    raise unless book?

    SPELCODE[ @arg ]
    
  end

  def deadthrone?
    @id == ODEADTHRONE
  end

  def fountain?
    @id == OFOUNTAIN
  end
  
  def deadfountain?
    @id == ODEADFOUNTAIN
  end

  def chest? ; @id == OCHEST ; end
  
  def Larnobject.chest( level )
    self.new( OCHEST, level )
  end

  
  def Larnobject.deadthrone
    self.new( ODEADTHRONE )
  end
  
  def Larnobject.deadfountain
    self.new( ODEADFOUNTAIN )
  end

  def Larnobject.throne
    self.new( OTHRONE )
  end
  
  def Larnobject.throne2
    self.new( OTHRONE2 )
  end

  def orb?
    @id == OORB
  end
  
  FOUND = {
    OTRAPARROWIV => OTRAPARROW,  # 櫡
    OIVTELETRAP  => OTELEPORTER, # ƥݡȡ
    OIVDARTRAP   => ODARTRAP,    # ȡ
    OIVTRAPDOOR  => OTRAPDOOR,   # Ȥꡣ
  }
  
  def trapdoor?; @id == OTRAPDOOR ; end

  def trap_teleporter?
    @id == OIVTELETRAP || @id == OTELEPORTER
  end

  def trap_arrow?
    @id == OTRAPARROWIV || @id == OTRAPARROW
  end

  def trap_dart?
    @id == OIVDARTRAP || @id == ODARTRAP
  end

  def trap_door?
    @id == OIVTRAPDOOR || @id ==OTRAPDOOR
  end
  
  
  def trap?
    FOUND.key?( @id ) || FOUND.value?( @id )
  end
  
  def found
    return unless hidden?

    @id = FOUND[ @id ]

  end

  def found? ; !hidden? ; end
  
  def hidden?
    FOUND.key?( @id )
  end

  def exit?
    @id == OEXIT
  end

  def throne?  ; @id == OTHRONE  ; end
  def throne2? ; @id == OTHRONE2 ; end 

  def closeddoor? ; @id == OCLOSEDDOOR ; end
  def opendoor?   ; @id == OOPENDOOR ; end

  def closed

    raise unless opendoor?
    
    @id = OCLOSEDDOOR
    @arg = 0

  end

  def opened

    raise unless closeddoor?
    
    @id  = OOPENDOOR
    @arg = 0
    
  end

  

  def lance? ; @id == OLANCE ; end

  WEAPON = {
    ODAGGER          =>  3,
    OBELT            =>  7,
    
    # ɤȤƻȤäͭɥå
    OSHIELD          =>  8, 

    OSPEAR           => 10,
    OFLAIL           => 14,
    OBATTLEAXE       => 17, 
    OLANCE           => 19,
    OLONGSWORD       => 22,
    O2SWORD          => 26,
    OSWORD           => 32,
    OSWORDofSLASHING => 30,
    OHAMMER          => 35,
  }

  def twohanded?
    @id == O2SWORD
  end

  
  def wclass
    WEAPON.key?( @id ) ? ( WEAPON[ @id ] + @arg ) : 0
  end
  
  def wclass_up

    case @id
    when ODAMRING
      @arg + 1
    when OBELT
      ( @arg << 1 ) + 2
    else
      0
    end

  end

  def weapon_dulled
    # Larn 12.0ꡣwclassޥʥˤʤ뤳ȤͭΤǽ
    # @arg -= 1 if ( @arg > -10 )
    
    @arg -= 1 if ( wclass > 0 )

  end
  
  ANTI_RUST = [
    OLEATHER, 
    OSSPLATE,
  ]
  
  def eaten
    return if ANTI_RUST.include?( @id )
    @arg -= 1 if ac > 1
  end

  def leather?
    @id == OLEATHER
  end

  def ssplate?
    @id == OSSPLATE
  end

  def notheft?
    @id == ONOTHEFT
  end
  
  ARMOR = {
    OLEATHER     =>   2,
    OSTUDLEATHER =>   3,
    ORING        =>   5,
    OCHAIN       =>   6,
    OSPLINT      =>   7,
    OPLATE       =>   9,
    OPLATEARMOR  =>  10,
    OSSPLATE      => 12,
  }

  SHIELD = {
    OSHIELD      =>   2,
  }
  
  def ac

    if ARMOR.include?( @id )
      ARMOR[ @id ] + @arg
    elsif SHIELD.include?( @id )
      SHIELD[ @id ] + @arg
    else
      0
    end

  end

  def wearable?  ; armor? || shield?            ; end
  def wieldable? ; weapon? || ring? || shield?  ; end 
  def readable?  ; book? || scroll?             ; end

  
  def ac_up
    ( @id == OPROTRING ) ? ( 1 + @arg ) : 0
  end

  def strextra

    case @id
    when OSTRRING
      @arg + 1
    when OHAMMER # ϥޡ֤ۤϡϼȤȤǡ
      10
    else
      0
    end

  end
    
  def intelligence_up

    case @id
    when OCLEVERRING
      @arg + 1
    when OHAMMER # ϥޡ֤ۤˤϡΤʤȤȤǡ
      -10
    else
      0
    end

  end

  def invisibility_up ; amulet? ? ( 1 + @arg ) : 0 ; end
  
  
  def dexterity_up

    case @id
    when ODEXRING
      @arg + 1
    when OHAMMER # ϥޡ֤ۤϡ褬ѤȤȤ???
      10
    when OSWORDofSLASHING
      5
    else
      0
    end
  
  end

  RING = [
    ORINGOFEXTRA, 
    OREGENRING,
    OPROTRING,
    OENERGYRING,
    ODEXRING,
    OSTRRING,
    OCLEVERRING,
    ODAMRING,
  ]
  
  def ring?   ; RING.include?( @id ) ; end
  def weapon? ; WEAPON.key?( @id )   ; end
  def shield? ; SHIELD.key?( @id )   ; end
  def armor?  ; ARMOR.key?( @id )    ; end 
  def amulet? ; @id == OAMULET       ; end
  
  def enchantable?
    ring? || weapon? || armor? || belt? || shield? || amulet?
  end
  
  def enchant
    ( enchantable? ) ? @arg : 0
  end

  def enchanted
    @arg += 1 if enchantable?
  end
  
  def slaying
    ( @id == OORBOFDRAGON ) ? 1 : 0
  end

  def Larnobject.dropgold( amount )
    self.new( OGOLDPILE, amount )
  end

  alias_method( :amount, :arg )

  # ʪ
  def scroll? ; @id == OSCROLL ; end

  def enchant_armor?      ; scroll? && ( @arg ==  0 ) ; end
  def enchant_weapon?     ; scroll? && ( @arg ==  1 ) ; end
  def enlightenment?      ; scroll? && ( @arg ==  2 ) ; end
  def blank_paper?        ; scroll? && ( @arg ==  3 ) ; end
  def create_monster?     ; scroll? && ( @arg ==  4 ) ; end
  def create_artifact?    ; scroll? && ( @arg ==  5 ) ; end
  def aggravate_monsters? ; scroll? && ( @arg ==  6 ) ; end
  def time_warp?          ; scroll? && ( @arg ==  7 ) ; end
  def teleportation?      ; scroll? && ( @arg ==  8 ) ; end
  def expanded_awareness? ; scroll? && ( @arg ==  9 ) ; end
  def haste_monsters?     ; scroll? && ( @arg == 10 ) ; end
  def monster_healing?    ; scroll? && ( @arg == 11 ) ; end
  def spirit_protection?  ; scroll? && ( @arg == 12 ) ; end
  def undead_protection?  ; scroll? && ( @arg == 13 ) ; end
  def stealth?            ; scroll? && ( @arg == 14 ) ; end
  def magic_mapping?      ; scroll? && ( @arg == 15 ) ; end
  def hold_monsters?      ; scroll? && ( @arg == 16 ) ; end
  def gem_perfection?     ; scroll? && ( @arg == 17 ) ; end
  def spell_extension?    ; scroll? && ( @arg == 18 ) ; end
  def identify?           ; scroll? && ( @arg == 19 ) ; end
  def remove_curse?       ; scroll? && ( @arg == 20 ) ; end
  def annihilation?       ; scroll? && ( @arg == 21 ) ; end
  def pulverization?      ; scroll? && ( @arg == 22 ) ; end
  def life_protection?    ; scroll? && ( @arg == 23 ) ; end

  # 
  def potion? ; @id == OPOTION ; end

  def sleep?              ; potion? && ( @arg ==  0 ) ; end
  def healing?            ; potion? && ( @arg ==  1 ) ; end
  def raise_level?        ; potion? && ( @arg ==  2 ) ; end
  def increase_ability?   ; potion? && ( @arg ==  3 ) ; end
  def wisdom?             ; potion? && ( @arg ==  4 ) ; end
  def strength?           ; potion? && ( @arg ==  5 ) ; end
  def raise_charisma?     ; potion? && ( @arg ==  6 ) ; end
  def dizziness?          ; potion? && ( @arg ==  7 ) ; end
  def learning?           ; potion? && ( @arg ==  8 ) ; end
  def gold_detection?     ; potion? && ( @arg ==  9 ) ; end
  def monster_detection?  ; potion? && ( @arg == 10 ) ; end
  def forgetfulness?      ; potion? && ( @arg == 11 ) ; end
  def water?              ; potion? && ( @arg == 12 ) ; end
  def blindness?          ; potion? && ( @arg == 13 ) ; end
  def confusion?          ; potion? && ( @arg == 14 ) ; end
  def heroism?            ; potion? && ( @arg == 15 ) ; end
  def sturdiness?         ; potion? && ( @arg == 16 ) ; end
  def giant_strength?     ; potion? && ( @arg == 17 ) ; end
  def fire_resistance?    ; potion? && ( @arg == 18 ) ; end
  def treasure_finding?   ; potion? && ( @arg == 19 ) ; end
  def instant_healing?    ; potion? && ( @arg == 20 ) ; end
  def cure_dianthroritis? ; potion? && ( @arg == 21 ) ; end
  def poison?             ; potion? && ( @arg == 22 ) ; end
  def see_invisible?      ; potion? && ( @arg == 23 ) ; end
  
  GEM = [
    ODIAMOND,
    ORUBY,
    OEMERALD,
    OSAPPHIRE
  ]

  def gem? ; GEM.include?( @id ) ; end
  
  def gem_perfection
    return unless gem?
    @arg = 255 if ( ( @arg = ( @arg << 1 ) ) > 255 )
  end

  def altar? ; @id == OALTAR ; end
  def pit?   ; @id == OPIT ; end


  
  def leprechaun_love? ; gold? || gem? ; end

  def spiritscarab? ; ( @id == OSPIRITSCARAB ) ; end

  def cubeofundead? ;  ( @id == OCUBEofUNDEAD ) ; end 

  def disenchant
    @arg = 0 if ( enchant > 0 ) && ( ( @arg -= 3 ) < 0 ) 
  end

  # ١2Larn 12.0Ǥ̤ѡ
  def elevatorup?   ; @id == OELEVATORUP   ; end
  def elevatordown? ; @id == OELEVATORDOWN ; end
  
  def lrs? ; @id == OLRS ; end
  def tradepost? ; @id == OTRADEPOST ; end
  def school? ; @id == OSCHOOL ; end

  DND_LIST = [

    # 1ڡܡ
    # ,    ࡢ               enchant(arg),   Ŀ
    
    [     2,   OLEATHER,            0,              3       ], # a
    [    10,   OSTUDLEATHER,        0,              2       ], # b
    [    40,   ORING,               0,              2       ], # c
    [    85,   OCHAIN,              0,              2       ], # d
    [   220,   OSPLINT,             0,              1       ], # e
    [   400,   OPLATE,              0,              1       ], # f
    [   900,   OPLATEARMOR,         0,              1       ], # g
    [  2600,   OSSPLATE,            0,              1       ], # h
    [   150,   OSHIELD,             0,              1       ], # i
    [     2,   ODAGGER,             0,              3       ], # j
    [    20,   OSPEAR,              0,              3       ], # k
    [    80,   OFLAIL,              0,              2       ], # l
    [   150,   OBATTLEAXE,          0,              2       ], # m
    [   450,   OLONGSWORD,          0,              2       ], # n
    [  1000,   O2SWORD,             0,              2       ], # o
    [  5000,   OSWORD,              0,              1       ], # p
    [ 16500,   OLANCE,              0,              1       ], # q 
    [  6000,   OSWORDofSLASHING,    0,              0       ], # r
    [ 10000,   OHAMMER,             0,              0       ], # s
    [   150,   OPROTRING,           1,              1       ], # t
    [    85,   OSTRRING,            1,              1       ], # u
    [   120,   ODEXRING,            1,              1       ], # v
    [   120,   OCLEVERRING,         1,              1       ], # w
    [   180,   OENERGYRING,         0,              1       ], # x
    [   125,   ODAMRING,            0,              1       ], # y
    [   220,   OREGENRING,          0,              1       ], # z

    # 2ڡܡ
    # , ࡢղò( enchant ), Ŀ

    [  1000,   ORINGOFEXTRA,        0,              1       ], # a
    [   280,   OBELT,               0,              1       ], # b
    [   400,   OAMULET,             0,              1       ], # c
    [  6500,   OORBOFDRAGON,        0,              0       ], # d
    [  5500,   OSPIRITSCARAB,       0,              0       ], # e
    [  5000,   OCUBEofUNDEAD,       0,              0       ], # f
    [  6000,   ONOTHEFT,            0,              0       ], # g
    [   590,   OCHEST,              6,              1       ], # h
    [   200,   OBOOK,               8,              1       ], # i
    [    10,   OCOOKIE,             0,              3       ], # j
    [    20,   OPOTION,             0,              6       ], # k
    [    90,   OPOTION,             1,              5       ], # l
    [   520,   OPOTION,             2,              1       ], # m
    [   100,   OPOTION,             3,              2       ], # n
    [    50,   OPOTION,             4,              2       ], # o
    [   150,   OPOTION,             5,              2       ], # p
    [    70,   OPOTION,             6,              1       ], # q
    [    30,   OPOTION,             7,              7       ], # r
    [   200,   OPOTION,             8,              1       ], # s
    [    50,   OPOTION,             9,              1       ], # t
    [    80,   OPOTION,            10,              1       ], # u
    [    30,   OPOTION,            11,              3       ], # v
    [    20,   OPOTION,            12,              5       ], # w
    [    40,   OPOTION,            13,              3       ], # x
    [    35,   OPOTION,            14,              2       ], # y
    [   520,   OPOTION,            15,              1       ], # z

    # 3ڡܡ
    # ,    ࡢ               enchant(arg),   Ŀ

    [    90,   OPOTION,            16,              2       ], # a
    [   200,   OPOTION,            17,              2       ], # b
    [   220,   OPOTION,            18,              4       ], # c
    [    80,   OPOTION,            19,              6       ], # d
    [   370,   OPOTION,            20,              3       ], # e 
    [    50,   OPOTION,            22,              1       ], # f
    [   150,   OPOTION,            23,              3       ], # g
    [   100,   OSCROLL,             0,              2       ], # h
    [   125,   OSCROLL,             1,              2       ], # i
    [    60,   OSCROLL,             2,              4       ], # j
    [    10,   OSCROLL,             3,              4       ], # k
    [   100,   OSCROLL,             4,              3       ], # l
    [   200,   OSCROLL,             5,              2       ], # m
    [   110,   OSCROLL,             6,              1       ], # n
    [   500,   OSCROLL,             7,              2       ], # o
    [   200,   OSCROLL,             8,              2       ], # p
    [   250,   OSCROLL,             9,              4       ], # q
    [    20,   OSCROLL,            10,              5       ], # r
    [    30,   OSCROLL,            11,              3       ], # s
    [   340,   OSCROLL,            12,              1       ], # t
    [   340,   OSCROLL,            13,              1       ], # u
    [   300,   OSCROLL,            14,              2       ], # v
    [   400,   OSCROLL,            15,              2       ], # w
    [   500,   OSCROLL,            16,              2       ], # x
    [  1000,   OSCROLL,            17,              1       ], # y
    [   500,   OSCROLL,            18,              1       ], # z

    # 4ڡܡ
    # ,    ࡢ               enchant(arg),   Ŀ

    [   340,   OSCROLL,            19,              2       ], # a
    [   220,   OSCROLL,            20,              3       ], # b
    [  3900,   OSCROLL,            21,              0       ], # c
    [   610,   OSCROLL,            22,              1       ], # d
    [  3000,   OSCROLL,            23,              0       ], # e

  ]

  def Larnobject.dndstore
    self.new( ODNDSTORE, DND_LIST.dup )
  end

  def sold( page, num )
    index = page * 26 + num
    
    @arg[ index ][ 3 ] -= 1
    Larnobject.new( @arg[ index ][ 1 ], @arg[ index ][ 2 ] )

  end
   
  # tradepostѡ͡ʤȤˤnil

  def price_for_tradepost

    # Фξ:
    return( 20 * @arg ) if gem?

    # ʪȿξ:
    if scroll?
      return( 2 * DND_LIST[ 58 + @arg ][ 0 ] )
    elsif potion?
      return( 2 * DND_LIST[ 36 + @arg ][ 0 ] )
    end
      
    # DND_LIST˹ܤ륢ƥʳϡ㤤Բġ
    DND_LIST.each do | price, id, arg, |

      next unless id == @id

      price *= 2 if @arg >= 0

      @arg.times do
	break if ( ( price = ( 14 * ( 67 + price ) / 10 ) ) > 500000 )

	# Larnˡ㤤ͤ⤹
	# ˡǡLance of Death٤㤨ƤޤΤǡĴƤޤ
	
	break if book? && ( price > 5000 )
      end
      
      return price
      
    end

    nil # 㤤ݡ

  end

  def bank_buy?
    gem? || larneye?
  end

  
  # ԤΥƥ㤤ʡ
  # Ф˹ͤĤޤEye of Larn٤ͤ㤤äƤޤ
  
  def price_for_bank( gtime )

    return nil if ( !gem? && !larneye? ) # 㤤ݡ

    if gem?
      ( 255 & @arg ) * 100
    elsif larneye?
      gemvalue = 250000- ( gtime * 7 ) 
      ( gemvalue > 50000 ) ? gemvalue : 50000
    else
      nil # 㤤ݡ
    end

  end
  
  STORE = [
    OSCHOOL,
    OBANK,
    OBANK2,
    OTRADEPOST,
    OHOME,
    ODNDSTORE,
    OLRS
  ]

  def store? ; STORE.include?( @id ) ; end
  def bank?  ; @id == OBANK  ; end
  def bank2? ; @id == OBANK2 ; end
  def dndstore? ; @id == ODNDSTORE ; end

  def door_aggravate?     ; closeddoor? && ( @arg == 6 ) ; end
  def door_electric?      ; closeddoor? && ( @arg == 7 ) ; end
  def door_drainlevel?    ; closeddoor? && ( @arg == 8 ) ; end
  def door_strength_down? ; closeddoor? && ( @arg == 9 ) ; end


  def regen_up

    return( @arg + 1 )        if @id == OREGENRING
    return( 5 * ( @arg+ 1 ) ) if @id == ORINGOFEXTRA

    0
    
  end

  def energy_up ; ( @id == OENERGYRING ) ? 1 + @arg : 0 ; end

  def weight

    case @id
    when OSSPLATE, OPLATEARMOR
      40
    when OPLATE
      35
    when OCHEST
      30 + @arg 
    when OHAMMER
      30
    when OSPLINT
      26
    when OSWORDofSLASHING, OCHAIN, OBATTLEAXE, O2SWORD
      23
    when OLONGSWORD, OSWORD, ORING, OFLAIL
      20
    when OLANCE, OSTUDLEATHER
      15
    when OLEATHER, OSPEAR
      8
    when OSHIELD
      7
    when OORBOFDRAGON, OBELT
      4
    else
      1
    end

  end

  def Larnobject.altar
    self.new( OALTAR )
  end

  def Larnobject.closeddoor( arg = rnd( 30 ) )
    self.new( OCLOSEDDOOR, arg )
  end
  
  def voldown? ; @id == OVOLDOWN ; end
  def volup?   ; @id == OVOLUP   ; end

  def Larnobject.cure_dianthroritis
    self.new( OPOTION, 21 )
  end
  
end
