module Utility

  DIR_ARRAY = [ ?h, ?j, ?k, ?l, ?y, ?u, ?b, ?n ]
  
  def shuffle_dirs

    dirs = DIR_ARRAY.dup

    10.times do

      i = rand( 8 )
      j = rand( 8 )

      tmp = dirs[ j ]
      dirs[ j ] = dirs[ i ]
      dirs[ i ] = tmp

    end

    dirs
    
  end
  
  def opposite_dir( dir )
    "lkjhnbuy"[ "hjklyubn".index( dir ) ]
  end

  # point濴Ȥdir

  def next_point( point, dir )
  
    row, col = point
    
    # 
    case dir
    when ?h, ?y, ?b
      col -= 1
    when ?l, ?u, ?n
      col += 1
    end
    
    # 
    case dir
    when ?k, ?y, ?u
      row -= 1
    when ?j,?b,?n
      row += 1
    end
  
    [ row, col ]
    
  end

end
