require "constant"
require "larnobject"
require "resist"

class Monster

  include Constant::Monster
  include Resist
  
  ALL_MONSTERS = 64 # 1 <= @id <= 64

  # Ի줿󥹥
  # ԻоݤˤʤΤϡƱ쥢ե٥åȤΥ󥹥Ǻǲ̤ΤΡ
  # ǡϷ褷ƵԻоݤˤʤʤ
  
  @@genocided = []
  
  MONCHAR = " BGHJKOScjtAELNQRZabhiCTYdegmvzFWflorXVIpqsyUkMwDDPxnDDuD        "
  
  
  MONSTER = [
    [],

    # LV   AC      DAM    ATT     DEF      GEN INT  GOLD    HP       EXP

    # BAT = 1
    [  1,   0,       1,     0,      0,       0,  3,    0,    1,        1 ],

    # GNOME =  2
    [  1,  10,       1,     0,      0,       0,  8,   30,    2,        2 ],

    # HOBGOBLIN = 3
    [  1,  14,       2,     0,      0,       0,  5,   25,    3,        2 ],

    # JACKAL = 4
    [  1,  17,       1,     0,      0,       0,  4,    0,    1,        1 ],

    # KOBOLD = 5
    [  1,  20,       1,     0,      0,       0,  7,   10,    1,        1 ],

    # ORC = 6
    [  2,  12,       1,     0,      0,       0,  9,   40,    4,        2 ],

    # SNAKE = 7
    [  2,  15,       1,     0,      0,       0,  3,    0,    3,        1 ],

    # CENTIPEDE = 8
    [  2,  14,       0,     4,      0,       0,  3,    0,    1,        2 ],

    # JACULI = 9
    [  2,  20,       1,     0,      0,       0,  3,    0,    2,        1 ],

    # TROGLODYTE = 10
    [  2,  10,       2,     0,      0,       0,  5,   80,    4,        3 ],

    # ANT = 11
    [  2,   8,       1,     4,      0,       0,  4,    0,    5,        5 ],

    # LV   AC      DAM    ATT     DEF     GEN  INT  GOLD    HP       EXP

    # EYE = 12
    [  3,   8,       1,     0,      0,       0,  3,    0,    5,        2 ],

    # LEPRECHAUN = 13
    [  3,   3,       0,     8,      0,       0,  3, 1500,   13,       45 ],

    # NYMPH = 14
    [  3,   3,       0,    14,      0,       0,  9,    0,   18,       45 ],

    # QUASIT = 15
    [  3,   5,       3,     0,      0,       0,  3,    0,   10,       15 ],

    # RUSTMONSTER = 16
    [  3,   4,       0,     1,      0,       0,  3,    0,   18,       25 ],

    # ZOMBIE = 17
    [  3,  12,       2,     0,      0,       0,  3,    0,    6,        7 ],

    # ASSASSINBUG = 18
    [  4,   9,       3,     0,      0,       0,  3,    0,   20,       15 ],

    # BUGBEAR = 19
    [  4,   5,       4,    15,      0,       0,  5,   40,   20,       35 ],

    # HELLHOUND = 20
    [  4,   5,       2,     2,      0,       0,  6,    0,   16,       35 ],

    # ICELIZARD = 21
    [  4,  11,       2,    10,      0,       0,  6,   50,   16,       25 ],

    # CENTAUR = 22
    [  4,   6,       4,     0,      0,       0, 10,   40,   24,       45 ],

    #  LV   AC     DAM    ATT     DEF      GEN INT GOLD     HP       EXP

    # TROLL = 23
    [  5,    4,      5,     0,      0,       0,  9,   80,   50,      300 ],

    # YETI = 24
    [  5,    6,      4,     0,      0,       0,  5,   50,   35,      100 ],

    # WHITEDRAGON = 25
    [  5,    2,      4,     5,      0,       0, 16,  500,   55,     1000 ],
    
    # ELF = 26
    [  5,    8,      1,     0,      0,       0, 15,   50,   22,       35 ],

    # CUBE = 27
    [  5,    9,      1,     0,      0,       0,  3,    0,   22,       45 ],

    # METAMORPH = 28
    [  6,    7,      3,     0,      0,       0,  3,    0,   30,       40 ],

    # VORTEX = 29
    [  6,    4,      3,     0,      0,       0,  3,    0,   30,       55 ],  

    # ZILLER = 30
    [  6,   15,      3,     0,      0,       0,  3,    0,   30,       35 ],

    # VIOLETFUNGI = 31
    [  6,   12,      3,     0,      0,       0,  3,    0,   38,      100 ],

    # WRAITH = 32
    [  6,    3,      1,     6,      0,       0,  3,    0,   30,      325 ],

    # FORVVALAKA = 33
    [  6,    2,      5,     0,      0,       0,  7,    0,   50,      280 ],
    
    # LV    AC     DAM    ATT     DEF      GEN INT  GOLD    HP       EXP

    # LAMANOBE = 34
    [  7,    7,      3,     0,      0,       0,  6,    0,   35,       80 ],

    # OSEQUIP = 35
    [  7,    4,      3,    16,      0,       0,  4,    0,   35,      100 ],

    # ROTHE = 36
    [  7,   15,      5,     0,      0,       0,  3,  100,   50,      250 ],

    # XORN = 37
    [  7,    0,      6,     0,      0,       0, 13,    0,   60,      300 ],

    # VAMPIRE = 38
    [  7,    3,      4,     6,      0,       0, 17,    0,   50,     1000 ],

    # INVISIBLESTALKER = 39
    [  7,    3,      6,     0,      0,       0,  5,    0,   50,      350 ],

    # POLTERGEIST = 40
    [  8,    1,      4,     0,      0,       0,  3,    0,   50,      450 ],

    # DISENCHANTRESS = 41
    [  8,    3,      0,     9,      0,       0,  3,    0,   50,      500 ],

    # SHAMBLINGMOUND = 42
    [  8,    2,      5,     0,      0,       0,  6,    0,   45,      400 ],

    # YELLOWMOLD = 43
    [  8,   12,      4,     0,      0,       0,  3,    0,   35,      250 ],

    # UMBERHULK = 44
    [  8,    3,      7,    11,      0,       0, 14,    0,   65,      600 ],
    
    # LV    AC     DAM    ATT     DEF      GEN INT  GOLD    HP       EXP

    # GNOMEKING = 45
    [  9,   -1,     10,     0,      0,       0, 18, 2000,  100,     3000 ],

    # MIMIC = 46
    [  9,    5,      6,     0,      0,       0,  8,    0,   55,       99 ],

    # WATERLORD = 47
    [  9,  -10,     15,     7,      0,       0, 20,    0,  150,    15000 ],

    # BRONZEDRAGON = 48
    [  9,    2,      9,     3,      0,       0, 16,  300,   80,     4000 ],

    # GREENDRAGON = 49
    [  9,    3,      8,    10,      0,       0, 15,  200,   70,     2500 ],

    # PURPLEWORM = 50
    [  9,   -1,     11,     0,      0,       0,  3,  100,  120,    15000 ],

    # XVART = 51
    [  9,   -2,     12,     0,      0,       0, 13,    0,   90,     1000 ],

    # SPIRITNAGA = 52
    [ 10,  -20,     12,    12,      0,       0, 23,    0,   95,    20000 ],

    # SILVERDRAGON = 53
    [ 10,   -1,     12,     3,      0,       0, 20,  700,  100,    10000 ],

    # PLATINUMDRAGON = 54
    [ 10,   -5,     15,    13,      0,       0, 22, 1000,  130,    24000 ],

    # GREENURCHIN = 55
    [ 10,   -3,     12,     0,      0,       0,  3,    0,   85,     5000 ],

    # REDDRAGON = 56
    [ 10,   -2,     13,     3,      0,       0, 19,  800,  110,    14000 ],

    # LV    AC     DAM    ATT     DEF      GEN INT  GOLD    HP       EXP

    # DEMONLORD_1 = 57
    [ 12,  -30,     18,     0,      0,       0, 20,    0,  140,    50000 ],

    # DEMONLORD_2 = 58
    [ 13,  -30,     18,     0,      0,       0, 21,    0,  160,    75000 ],

    # DEMONLORD_3 = 59
    [ 14,  -30,     18,     0,      0,       0, 22,    0,  180,   100000 ],

    # DEMONLORD_4 = 60
    [ 15,  -35,     20,     0,      0,       0, 23,    0,  200,   125000 ],

    # DEMONLORD_5 = 61
    [ 16,  -40,     22,     0,      0,       0, 24,    0,  220,   150000 ],

    # DEMONLORD_6 = 62
    [ 17,  -45,     24,     0,      0,       0, 25,    0,  240,   175000 ],

    # DEMONLORD_7 = 63
    [ 18,  -70,     27,     6,      0,       0, 26,    0,  260,   200000 ],

    # DEMONPRINCE = 64
    [ 25, -127,     30,     6,      0,       0, 28,    0,  345,   300000 ],

    ]

  LV   = 0
  AC   = 1
  DAM  = 2
  ATT  = 3
  DEF  = 4
  GEN  = 5
  INT  = 6
  GOLD = 7
  HP   = 8
  EXP  = 9
  
  attr_reader :id
  attr_accessor :hp

  WAKEUP = [ ROTHE, POLTERGEIST, VAMPIRE ]
  
  def initialize( id )
    @id = id # 󥹥μࡣ
    @hp = maxhp
    @damaged = false
    @wake = WAKEUP.include?( @id )
  end
  
  def maxhp ; MONSTER[ @id ][ HP ] ; end

  def intelligence ; MONSTER[ @id ][ INT ] ; end
  def intelligent? ; intelligence > ( 10 - $HARDGAME ) ; end
    

  def wtw? ; false ; end # ȴԲġ
  
  def healing ; @hp = maxhp ; end
  
  def level      ; MONSTER[ @id ][ LV ] ; end
  def ac         ; MONSTER[ @id ][ AC ]   ; end
  def experience ; MONSTER[ @id ][ EXP ]  ; end
  def gold
    
    amount = MONSTER[ @id ][ GOLD ]
    rnd( amount ) + amount
    
  end

  # ץ쥤䡼äɤ?
  def damaged? ; false ; end
  
  def wakeup ; @wake = true ; end
  def wakeup? ; @wake ; end
  def asleep? ; !@wake ; end
  
  
  MONSTLEVEL = [ 5, 5, 11, 17, 22, 27, 33, 39, 42, 46, 50, 53, 56, 56 ]
  
  def Monster.create( level, up = 0 )

    level = 13 if ( level > 13 )

    id = 0
    
    loop do
      
      id = if ( level < 5 )
	     rand( MONSTLEVEL[ level ] ) + 1
	   else
	     rand( MONSTLEVEL[ level ] - MONSTLEVEL[ level - 3 ] ) + 1 + MONSTLEVEL[ level - 3 ] # 56ޤǡ
	   end

      break if ( id += up ) != WATERLORD # Τߤ˽и

    end

    while @@genocided.include?( id )
      id += 1 
    end
    
    id = DEMONPRINCE if id > DEMONPRINCE

    self.new( id )
    
  end

  def Monster.genocided?( mon )
    @@genocided.include?( mon.id )
  end

  def Monster.random_demon
    self.new( get_rand( DEMONLORD_1, DEMONPRINCE ) )
  end
  
  def Monster.demonprince ; self.new( DEMONPRINCE ) ; end
  def Monster.waterlord   ; self.new( WATERLORD )   ; end
  def Monster.gnomeking   ; self.new( GNOMEKING )   ; end
  def Monster.bat         ; self.new( BAT )         ; end
  
  # ǡ²ɤ?
  # @idDEMONLORD_1DEMONPRINCEδ֤Ǥ뤫ɤ?
  
  def demon?
    @id.between?( DEMONLORD_1, DEMONPRINCE )
  end

  def invisiblestalker?
    @id == INVISIBLESTALKER
  end

  def method_missing( id, *param )
    false
  end

  # ΰϤ򲼤󥹥
  def dulled?
    ( @id == RUSTMONSTER ) || ( @id ==DISENCHANTRESS ) || ( @id ==CUBE )
  end

  DRAGON = [
    WHITEDRAGON,
    REDDRAGON,
    GREENDRAGON,
    BRONZEDRAGON,
    PLATINUMDRAGON,
    SILVERDRAGON
  ]
    
  # ɥ饴
  def dragon?

    # Larn 12.0Υɤˤϡ
    # /* if a dragon and orb(s) of dragon slaying       */
    # ȥȤƤޤOORBOFDRAGONϥƥషΤ褦Ǥ
    # ȯѹä?
    
    # ֡꡼Ƽ⡢䡣
    DRAGON.include?( @id )
          
  end

  def damaged( n )

    return if n < 0
    @hp -= n

  end

  def killed?
    @hp <= 0
  end

  def vampire? ; @id == VAMPIRE ; end
  def leprechaun? ; @id == LEPRECHAUN ; end
  
  def change_to_bat? ; vampire? && ( @hp < 25 ) ; end 

  # ƥȤ󥹥
  DROPSOMETHING = [
    ORC,
    NYMPH,
    ELF,
    TROGLODYTE,
    TROLL,
    ROTHE,
    VIOLETFUNGI,
    PLATINUMDRAGON,
    GNOMEKING,
    REDDRAGON
  ]

  def troll? ; @id == TROLL ; end
  def regenerate; @hp = maxhp if ( ( @hp += 1 ) > maxhp ) ; end

  
  def dropsomething? ; DROPSOMETHING.include?( @id ) ; end
  def dropgold? ; MONSTER[ @id ][ GOLD ] > 0 ; end

  # ⼡Υǡˤannihilationϸʤ
  def anti_annihilation? ; @id > DEMONLORD_2 ; end

  def annihilated # HPȾ
    @hp = ( @hp >> 1 + 1 )
  end

  def resist_spell?( spell )

    if spell.magic_missile?
      RESIST_MAGIC_MISSILE[ @id ]
    elsif spell.sleep?
      RESIST_SLEEP[ @id ]
    elsif spell.charm_monster?
      RESIST_CHARM_MONSTER[ @id ]
    elsif spell.sonic_spear?
      RESIST_SONIC_SPEAR[ @id ]
    elsif spell.web?
      RESIST_WEB[ @id ]
    elsif spell.phantasmal_forces?
      RESIST_PHANTASMAL_FORCES[ @id ]
    elsif spell.invisibility?
      RESIST_INVISIBILITY[ @id ]
    elsif spell.cold?
      RESIST_COLD[ @id ]
    elsif spell.polymorph?
      RESIST_POLYMORPH[ @id ]
    elsif spell.cloud_kill?
      RESIST_CLOUD_KILL[ @id ]
    elsif spell.dehydration?
      RESIST_DEHYDRATION[ @id ]
    elsif spell.flood?
      RESIST_FLOOD[ @id ]
    elsif spell.finger_of_death?
      RESIST_FINGER_OF_DEATH[ @id ]
    elsif spell.scare_monster?
      RESIST_SCARE_MONSTER[ @id ]
    elsif spell.magic_fire?
      RESIST_MAGIC_FIRE[ @id ]
    elsif spell.sphere_of_annihilation?
      RESIST_SPHERE_OF_ANNIHILATION[ @id ]
    else
      nil
    end

  end

  # Demon PrinceʳΥ󥹥Ѥ롣
  def polymorph

    # ǡϷ褷genocideʤΤǡ
    # ʲΥ롼פɬޤ
    loop do
      next if ( @id = rnd( ALL_MONSTERS ) ) == DEMONPRINCE
      break unless @@genocided.include?( @id )
    end

    # HPκƥåȡ
    @hp = MONSTER[ id ][ HP ]
    
  end

  def xorn? ; @id == XORN ; end

  # sphereäƤȤˡsphereǤǤ뤫ɤ?
  def dispel_sphere?
    @id > DEMONLORD_4 || disenchantress?
  end

  # ưsphereäȤˡsphereǤǤ뤫ɤ?
  # Larn 12.0ξ硢dispel_sphere?̤Ƥ褦Ǥ
  
  def move_dispel_sphere?
    @id > DEMONLORD_3
  end
  
  def disenchantress?
    @id == DISENCHANTRESS
  end
  

  def Monster.genocide( asciicode )
    
    id = MONCHAR.index( asciicode )
    @@genocided.push( id ) if id && !@@genocided.include?( id )

    id
    
  end

  # 2˰γǤưǤʤ󥹥Ǥ
  SLOW = [
    TROGLODYTE,
    HOBGOBLIN,
    METAMORPH,
    XVART,
    INVISIBLESTALKER,
    ICELIZARD,
  ]

  def slow? ; SLOW.include?( @id ) ; end

  # def normal? ; !vampire? && !intelligent? ; end
  
  # Ȥ䡢ܤǤ⡢ʤ󥹥
  # ٤?
  
  NOT_FALL = [
    SPIRITNAGA,
    PLATINUMDRAGON,
    WRAITH,
    VAMPIRE,
    SILVERDRAGON,
    POLTERGEIST,
    DEMONLORD_1,
    DEMONLORD_2,
    DEMONLORD_3,
    DEMONLORD_4,
    DEMONLORD_5,
    DEMONLORD_6,
    DEMONLORD_7,
    DEMONPRINCE,
  ]

  def fall? ; !( NOT_FALL.include?( @id ) ) ; end


  def traparrow( level ) ; @hp -= ( rnd( 10)  + level ) ; end
  def dartrap ; @hp -= rnd( 6 ) ; end

  # ųݤ󥹥
  SPIRIT = [
    POLTERGEIST,
    SPIRITNAGA
  ]
    
  def spiritual? ; SPIRIT.include?( @id ) ; end

  UNDEAD = [
    VAMPIRE,
    WRAITH,
    ZOMBIE
  ]

  def undead? ; UNDEAD.include?( @id ) ; end

  def maxdamage ; MONSTER[ @id ][ DAM ] ; end

  
  def damage

    return 1 if ( @id == BAT )

    dam  = maxdamage
    dam += rnd( ( dam > 1 )? dam : 1 ) + level

    dam
    
  end

  def special_attack?
    attack > 0
  end

  def attack
    MONSTER[ @id ][ ATT ]
  end
  
  # ATTɽ
  
  EAT_ARMOR     =  1
  LIGHT_FIRE    =  2
  FIRE          =  3
  SING          =  4
  COLD_BREATH   =  5
  DRAIN_LEVEL   =  6
  WATER_GUSHER  =  7 
  STEAL_GOLD    =  8
  DISENCHANT    =  9
  BARBED_TAIL   = 10
  CONFUSION     = 11
  CAST_SPELLS   = 12
  PSIONICS      = 13
  STEAL_OBJECTS = 14
  BITE          = 15
  HARD_BITE     = 16
  
  def eat_armor?     ; attack == EAT_ARMOR     ; end
  def light_fire?    ; attack == LIGHT_FIRE    ; end
  def fire?          ; attack == FIRE          ; end
  def sing?          ; attack == SING          ; end
  def cold_breath?   ; attack == COLD_BREATH   ; end
  def drain_level?   ; attack == DRAIN_LEVEL   ; end
  def water_gusher?  ; attack == WATER_GUSHER  ; end
  def steal_gold?    ; attack == STEAL_GOLD    ; end
  def disenchant?    ; attack == DISENCHANT    ; end
  def barbed_tail?   ; attack == BARBED_TAIL   ; end
  def confusion?     ; attack == CONFUSION     ; end
  def cast_spells?   ; attack == CAST_SPELLS   ; end
  def psionics?      ; attack == PSIONICS      ; end
  def steal_objects? ; attack == STEAL_OBJECTS ; end
  def bite?          ; attack == BITE          ; end
  def hard_bite?     ; attack == HARD_BITE     ; end

  # ü칶ϡ
  
  def light_fire   ; rnd( 15 ) +  8 ; end
  def fire         ; rnd( 20 ) + 25 ; end
  def cold_breath  ; rnd( 15 ) + 18 ; end
  def water_gusher ; rnd( 15 ) + 25 ; end
  def barbed_tail  ; rnd( 25 )      ; end
  def psionics     ; rnd( 15 ) + 30 ; end
  def bite         ; rnd( 10 ) +  5 ; end
  def hard_bite    ; rnd( 15 ) + 10 ; end
  


  
  
end

