require "getoptlong"

module Option

  GAME_OPTION = [
    
    # ǡ١ѤˡǤΥեѤ뤫PostgreSQLѤ뤫?
    # "file" or "postgresql"
    # [ "--database", GetoptLong::REQUIRED_ARGUMENT ],
    
    # åեΥѥꡣ
    [ "--mesgfile", GetoptLong::REQUIRED_ARGUMENT ],
    
    # ꡣ줾졢٥0-9ꤹ롣
    [ "-0", GetoptLong::NO_ARGUMENT ], 
    [ "-1", GetoptLong::NO_ARGUMENT ],
    [ "-2", GetoptLong::NO_ARGUMENT ],
    [ "-3", GetoptLong::NO_ARGUMENT ],
    [ "-4", GetoptLong::NO_ARGUMENT ],
    [ "-5", GetoptLong::NO_ARGUMENT ],
    [ "-6", GetoptLong::NO_ARGUMENT ],
    [ "-7", GetoptLong::NO_ARGUMENT ],
    [ "-8", GetoptLong::NO_ARGUMENT ],
    [ "-9", GetoptLong::NO_ARGUMENT ],

    # ꡣArgumentϡ0-9
    [ "--hardgame", GetoptLong::REQUIRED_ARGUMENT ],

    # եΥѥꡣ
    [ "--rcfile", GetoptLong::REQUIRED_ARGUMENT ],

    # 顼⡼
    [ "--color", GetoptLong::NO_ARGUMENT ],

    # ܸ첽к
    [ "--redrawwin", GetoptLong::NO_ARGUMENT ],
    [ "--redraw",    GetoptLong::NO_ARGUMENT ],

    # ǥХå
    [ "--wizard", GetoptLong::NO_ARGUMENT ],

    # ե륹꡼
    [ "--fullscreen", GetoptLong::NO_ARGUMENT ],

    # Kappa 20ɥåȥե
    [ "--kappa20",  GetoptLong::NO_ARGUMENT ],
    
  ]
  
  def get_game_option

    GetoptLong.new( *GAME_OPTION ).each do | opt, arg |
      update_game_option( opt, arg )
    end
    
  end

  def update_game_option( opt, arg )

    case opt
    when "--database"
      if arg == "file " || arg == "postgresql"
	$DATABASE = arg
      else
	raise "--database must be followed by file or postgresql."
      end
    when "--mesgfile"
      $MESGFILE = arg   
    when "-0", "-1", "-2", "-3", "-4", "-5", "-6", "-7", "-8", "-9"
      $HARDGAME = opt.to_i.abs
    when "--hardgame"
      $HARDGAME = arg.to_i.abs
      raise "--hardgame must be followed by 0 .. 9" unless $HARDGAME.between?( 0, 9 )
    when "--rcfile"
      $RCFILE = arg
    when "--color"
      $COLOR = true
    when "--redrawwin", "--redraw"
      $REDRAW = true
    when "--wizard"
      $WIZARD = true
    when "--fullscreen"
      $FULLSCREEN = true
    when "--kappa20"
      $KAPPA20 = true
    end
    
  end

end
