#! /usr/local/bin/ruby -Ke

require "constant"
require "larnobject"
require "monster"
require "player"
require "server"
require "random"
require "option"
require "readrc"

include Random
include Option

# 顼
$VERBOSE   = true
stderr_old = $stderr.dup
$stderr    = File.open( "./error.log", "a+b" )

$HARDGAME   = nil
$MESGFILE   = "larn.msg"     # message file path
$COLOR      = false          # 顼
$REDRAW     = nil
$WIZARD     = false
$FULLSCREEN = false

# ۡǥ쥯ȥˤӤѤե뤬Ȥˤϡ
# ͭ롣

$RCFILE    = "./rclientrc"

if ENV[ "HOME" ]
  path = ENV[ "HOME" ] + "/.rclientrc"
  $RCFILE = path if File.exist?( path )
end

# ץɤ߹ߡ
get_game_option

# եɤ߹ߡӤѥꡣ
name, password, url, port = readrc( $RCFILE )

require "client"

begin

  server = Server.new
  client = Client.new( name )

  # WindowsǤϡTrap̤б
  
  #  trap( "INT"  ){ client.multi_cancel }
  #  trap( "TSTP" ){ client.multi_cancel }
  #  trap( "QUIT" ){ client.multi_cancel }

  loop { server.accept( client ) }
  
ensure
  client.close if client
end
