require "constant"

module Wizard
  
  # ȢȤ
  def drop_chest( client, point )
    return unless $WIZARD
    put_object_near( client, Larnobject.chest( @level ), point )
  end

  def client_debug_get_amount( client, mesg )
    client.debug_get_amount( mesg )
  end

  
  # ʪȤ
  def drop_scroll( client, point )

    return unless $WIZARD
    
    # ʪμϤ롣
    arg = client_debug_get_amount( client, "Debug: Please input scroll arg  " )

    return if !( arg.is_a? Fixnum ) || !( arg.between?( 0, Constant::MAXSCROLL- 1) )
    message( client, client.player.mesg[ 540 + arg ] )
    put_object_near( client, Larnobject.newscroll( arg ), point )
    
  end

  def drop_potion( client, point )

    return unless $WIZARD
    
    # ʪμϤ롣
    arg = client_debug_get_amount( client, "Debug: Please input potion arg  " )
    
    return unless arg.is_a? Fixnum
    return unless arg.between?( 0, ( Constant::MAXPOTION - 1 ) )  

    message( client, client.player.mesg[ 600 + arg ] )
    put_object_near( client, Larnobject.newpotion( arg ), point )
    
  end

  def debug_spell_learn_id( client )

    return unless $WIZARD

    arg = client_debug_get_amount( client,
				  "Debug: Which spell do you want to learn? " )

    return unless arg.is_a?(  Fixnum )
    return unless arg.between?( 0, Constant::SPNUM - 1 )

    player = client.player
    mesg   = player.mesg
    
    player.learn_spell_id( arg )
    message( client, mesg[ 170 + arg ] )
    message( client, mesg[ 210 + arg ] )
    
  end
  
  def drop_altar( client, point )
    return unless $WIZARD
    put_object_near( client, Larnobject.altar, point )
  end

  def drop_mirror( client, point )
    return unless $WIZARD
    put_object_near( client, Larnobject.mirror, point )
  end

  def drop_throne( client, point )
    return unless $WIZARD
    put_object_near( client, Larnobject.throne, point )
  end
  
  def charge_tax( client )
    return unless $WIZARD
    client.player.charge( 100 )
  end

  def enough_gold( client )
    client.player.get_gold( 1000000 ) if $WIZARD
  end

  def debug_put_monster( client, point )

    return unless $WIZARD
    
    arg = client_debug_get_amount( client, "Debug: Please input monster id  " )

    return if !( arg.is_a? Fixnum ) || !( arg.between?( 1, Constant::ALL_MONSTERS ) )
    monster = Monster.new( arg )
    message( client, client.player.monstername( monster ) )
    # put_monster_near( client, monster, point )
    @cavelevel.random_put_monster( monster )
    
  end

  def debug_put_closeddoor( client, point )
    return unless $WIZARD
    arg = client_debug_get_amount( client, "Debug: Please input door arg  " )
    put_object_near( client, Larnobject.closeddoor( arg ), point )
  end
  
  def debug_raise_level( client )
    raise_level( client ) if $WIZARD
  end

  def debug_all_traps_found( client, point )
    return false unless $WIZARD
    @cavelevel.all_traps_found 
    showcell( client, point )
  end

  def debug_kill_100_mobuls( client )
    return false unless $WIZARD
    client.player.time_warp( 100 * 100 )
  end

  def debug_drop_gem( client, point )
    return unless $WIZARD
    put_object_near( client, Larnobject.new( 50 + rand( 4 ), 10 ), point )
  end

  def debug_identify_all( client )

    return unless $WIZARD
    
    player = client.player
    player.learn_all_spell
    player.identify_all_scroll
    player.identify_all_potion

  end
  
end
